/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VImportConfigTreeRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VImportConfigTree extends TableImpl<VImportConfigTreeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_import_config_tree</code>
     */
    public static final VImportConfigTree V_IMPORT_CONFIG_TREE = new VImportConfigTree();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VImportConfigTreeRecord> getRecordType() {
        return VImportConfigTreeRecord.class;
    }

    /**
     * The column <code>common_dd.v_import_config_tree.pk</code>.
     */
    public final TableField<VImportConfigTreeRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_import_config_tree.fk_import_config</code>.
     */
    public final TableField<VImportConfigTreeRecord, Integer> FK_IMPORT_CONFIG = createField(DSL.name("fk_import_config"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_import_config_tree.module</code>.
     */
    public final TableField<VImportConfigTreeRecord, String> MODULE = createField(DSL.name("module"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_import_config_tree.name</code>.
     */
    public final TableField<VImportConfigTreeRecord, String> NAME = createField(DSL.name("name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_import_config_tree.value</code>.
     */
    public final TableField<VImportConfigTreeRecord, String> VALUE = createField(DSL.name("value"), SQLDataType.CLOB, this, "");

    private VImportConfigTree(Name alias, Table<VImportConfigTreeRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VImportConfigTree(Name alias, Table<VImportConfigTreeRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_import_config_tree" as  SELECT pk,
         fk_import_config,
         module,
         name,
         value
        FROM ( WITH RECURSIVE t AS (
                      SELECT r.pk,
                         r.fk_import_config,
                         r.value AS module,
                         r.name,
                         r.value,
                         ARRAY[((r.name || '.'::text) || r.value)] AS path
                        FROM common_dd.t_import_config r
                       WHERE (r.fk_import_config IS NULL)
                     UNION ALL
                      SELECT c.pk,
                         c.fk_import_config,
                         t_1.module,
                         c.name,
                         c.value,
                         (t_1.path || ((c.name || '.'::text) || c.value))
                        FROM (common_dd.t_import_config c
                          JOIN t t_1 ON ((c.fk_import_config = t_1.pk)))
                     )
              SELECT t.pk,
                 t.fk_import_config,
                 t.module,
                 t.name,
                 t.value,
                 t.path
                FROM t
               ORDER BY t.path) sub;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_import_config_tree</code> table
     * reference
     */
    public VImportConfigTree(String alias) {
        this(DSL.name(alias), V_IMPORT_CONFIG_TREE);
    }

    /**
     * Create an aliased <code>common_dd.v_import_config_tree</code> table
     * reference
     */
    public VImportConfigTree(Name alias) {
        this(alias, V_IMPORT_CONFIG_TREE);
    }

    /**
     * Create a <code>common_dd.v_import_config_tree</code> table reference
     */
    public VImportConfigTree() {
        this(DSL.name("v_import_config_tree"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VImportConfigTree as(String alias) {
        return new VImportConfigTree(DSL.name(alias), this);
    }

    @Override
    public VImportConfigTree as(Name alias) {
        return new VImportConfigTree(alias, this);
    }

    @Override
    public VImportConfigTree as(Table<?> alias) {
        return new VImportConfigTree(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VImportConfigTree rename(String name) {
        return new VImportConfigTree(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VImportConfigTree rename(Name name) {
        return new VImportConfigTree(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VImportConfigTree rename(Table<?> name) {
        return new VImportConfigTree(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VImportConfigTree where(Condition condition) {
        return new VImportConfigTree(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VImportConfigTree where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VImportConfigTree where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VImportConfigTree where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VImportConfigTree where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VImportConfigTree where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VImportConfigTree where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VImportConfigTree where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VImportConfigTree whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VImportConfigTree whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
